config/routes.rb
Rails.application.routes.draw do

  get 'manage' => 'manage#index', as: :manage
  post 'manage' => 'manage#register_voter', as: :register_voter
  get 'results' => 'manage#results', as: :results

  get 'hello/:token' => 'vote#vote_options', as: :hello
  get 'vote/:token' => 'vote#vote', as: :vote
  post 'vote/:token' => 'vote#register_vote', as: :register_vote
  get 'thanks' => 'vote#thanks', as: :thanks
  get 'closed' => 'vote#closed', as: :closed
  match 'reminder', to: 'manage#send_mail_to_all', via: [:get, :post]

  mount RailsAdmin::Engine => '/backend', as: 'rails_admin'
  devise_for :admins
  get 'home/index'

  root to: 'home#index'

end

app/models/admin.rb
class Admin < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :rememberable, :trackable, :validatable
end

app/models/listing.rb
class Listing < ActiveRecord::Base
  has_many :votes
end

app/models/vote.rb
class Vote < ActiveRecord::Base
  belongs_to :listing
end

app/models/voter.rb
class Voter < ActiveRecord::Base
  has_secure_token
  after_create :send_email
  scope :not_voted, -> {where(:voted => nil)}

  rails_admin do
    import do
      include_all_fields
      exclude_fields :token, :voted
    end
  end

  # Resend link to user
  def send_link
    VoterMailer.link_email(self).deliver
  end
  # Resend link to user
  def remind
    VoterMailer.reminder_email(self).deliver_later
  end
  private
  def send_email
    VoterMailer.vote_email(self).deliver
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/manage_controller.rb
class ManageController < ApplicationController

  # noinspection RailsParamDefResolve
  before_filter :authenticate_admin!

  def index
  end

  def register_voter
    @voter = Voter.new voter_params
    @success = @voter.save
  end

  # noinspection RailsChecklist01
  def results
    @participation = (((Voter.where(voted: true).count.to_d)/(Voter.count.to_d)) * 100.0).to_d.round 2
    @results = {}
    @results['Votes Blancs'] = Voter.where(voted: true).count - Vote.count
    Listing.all.each do |list|
      @results[list.name] = list.votes.count
    end
  end

  def send_mail_to_all
    if request.post?
      Voter.all.to_a.each do |user|
        if user.voted
          VoterMailer.thanks_email(user).deliver_later unless user.thank_mail_sent
        else
          VoterMailer.reminder_email(user).deliver_later
        end
      end
      Voter.where(voted:true).update_all(thank_mail_sent:true)
    end
  end

  private
  def voter_params
    params.require(:voter).permit(:first_name, :last_name, :email)
  end
end

app/controllers/vote_controller.rb
class VoteController < ApplicationController

  before_filter :is_open?, only: [:vote, :register_vote]
  before_filter :set_voter, only: [:vote, :register_vote, :vote_options]

  def vote_options
    @lists = Listing.all.order :name
  end

  def vote
    @lists = Listing.all.order :name
    @vote = Vote.new listing_id: 546515613215
  end

  # noinspection RailsChecklist01
  def register_vote
    begin
      Vote.create! vote_params
    rescue
      # ignored
    end
    @voter.update! voted: true
    redirect_to :thanks
  end

  def thanks
  end

  def closed
  end

  private
  def is_open?
    now = Time.now
    opening = Time.parse(ENV['OPENING'])
    closing = Time.parse(ENV['CLOSING'])
    redirect_to :closed unless now > opening && now < closing
  end

  private
  def set_voter
    @voter = Voter.find_by_token(params[:token])
    if @voter.nil?
      raise ActiveRecord::RecordNotFound
    end
    if @voter.voted
      redirect_to :thanks
    end
  end

  def vote_params
    params.fetch(:vote).permit(:listing_id)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/manage_helper.rb
module ManageHelper
end

app/helpers/vote_helper.rb
module VoteHelper
end

app/views/home/index.html.erb
<h1 class="text-center">Elections BdE INSA Lyon</h1>
<p class="text-center">Vous êtes sur le serveur de gestion des élections du BdE INSA Lyon.
  Pour voter, veuillez utiliser le lien qui vous a été fourni par email.</p>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Elections BdE</title>
  <%= stylesheet_link_tag    'application', media: 'all' %>
  <%= javascript_include_tag 'application' %>
  <%= viewport_meta_tag(:maximum_scale => '1.0') %>
  <%= csrf_meta_tags %>
</head>
<body>

<div class="container">
  <div class="head text-center">
    <%= image_tag 'bde.png', width: '70px' %>
  </div>
  <%= bootstrap_flash %>
  <%= yield %>
  <footer class="text-center text-muted">
    &copy; 2017-2019 BdE INSA Lyon
  </footer>
</div>

</body>
</html>

app/views/vote/closed.html.erb
<h1 class="text-center">&Eacute;lection BdE INSA Lyon</h1>
<p>Les élections ne sont pas ouvertes pour le moment</p>
<p>Ouverture : Samedi 25 mai 2019 à 14h00</p>
<p>Fermeture : Samedi 1 juin 2019 à 23h59</p>

app/views/vote/thanks.html.erb
<h1 class="text-center">&Eacute;lections BdE INSA Lyon</h1>
<p>Merci d'avoir participé au vote !</p>
<p>Nous te donnons rendez-vous le <b>mardi 4 juin en amphi EMILE DU CHATELET (BMC) à 19h00 pour assister à l'Assemblée Générale des membres
  adhérents du BdE</b> au cours de laquelle seront communiqués les bilans moral et financier, ainsi que les résultats des
  votes !</p>

app/views/vote/vote.html.erb
<h1 class="text-center">Elections BdE INSA Lyon</h1>


<div class="row">
  <div class="col-md-4 col-md-offset-4 col-sm-6 col-sm-offset-3 col-xs-12 text-center">
    <p class="clearfix" style="margin-top:20px;">Sélectionnez votre vote&nbsp;</p>
    <%= form_for(@vote, url: {action: :register_vote, token: @voter.token}) do |f| %>
        <% @lists.each do |list| %>
            <div class="radio vote">
              <label>
                <%= f.radio_button :listing_id, list.id %> <%= list.name %>
              </label>
            </div>
        <% end %>
        <div class="radio vote">
          <label>
            <%= f.radio_button :listing_id, 0 %> Vote blanc
          </label>
        </div>
        <%= f.submit 'Voter', class: %w(btn btn-primary btn-block) %>
    <% end %>
  </div>
</div>

<!-- Modal -->
<div class="modal fade" id="confirmDialog" tabindex="-1" role="dialog">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title" id="myModalLabel">Confirmation</h4>
      </div>
      <div class="modal-body">
        Validez-vous votre participation aux élections du BdE INSA Lyon ?
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-danger pull-left" data-dismiss="modal">Non</button>
        <button type="button" class="btn btn-success" id="confirmButton">Oui</button>
      </div>
    </div>
  </div>
</div>

app/views/vote/vote_options.html.erb
<h1 class="text-center">Elections BdE INSA Lyon</h1>
<p>Chers adhérent(e)s,</p>
<p>Comme chaque année, le Bureau des Élèves procède au renouvellement du collège des membres adhérents (bureau),
  et c'est à vous de voter !</p>
<p>Pour information, le collège des membres adhérents compose la partie majoritaire dans le conseil d’administration du
  BdE. Les listes sont composées de 5 à 9 membres. Le collège des membres actifs vient compléter le conseil
  d’administration avec n-1 membres par rapport au collège des membres adhérents.</p>
<div class="row">
  <div class="col-md-4 col-md-offset-4 col-lg-2 col-lg-offset-5 col-sm-6 col-sm-offset-3">
    <a class="btn btn-primary btn-block" href="http://bde.insa-lyon.org/fr/content/colleges-bde-quest-ce-que-cest" aria-expanded="false" aria-controls="collapseExample">
      En savoir plus
    </a>
  </div>
</div>
<p></p>

<p class="clearfix" style="margin-top:20px;">Cette année, <%= @lists.length %> listes sont candidates, retrouve leur
  programme sur leur page Facebook ou site !</p>

<div class="row">
  <div class="col-xs-12 col-md-8 col-md-offset-2">
    <%= link_to "Aller voter", vote_url(token: @voter.token), class: %w(btn btn-block btn-primary) %>
  </div>
</div>
<p>&nbsp;</p>
<div class="row">
  <div class="col-xs-12 col-md-8 col-md-offset-2">
    <% @lists.each do |list| %>
        <div class="panel panel-default">
          <div class="panel-heading">
            <h4><%= list.name %></h4>
          </div>
          <div class="panel-body">
            <div class="row">
              <div class="col-xs-12">
                <p><%= simple_format(list.description) %></p>
                <p><b>Membres de la liste&nbsp;:</b> <%= simple_format(list.participants) %></p>
              </div>
            </div>
          </div>
          <div class="panel-footer">
            <%- unless list.facebook.nil? or list.facebook.empty? %>
                <a href="<%= list.facebook %>" target="_blank">Facebook</a>
            <% end %>
            <%- unless list.website.nil? or list.website.empty? %>
                <%- unless list.facebook.nil? or list.facebook.empty? %> -
                <% end %><a href="<%= list.website %>" target="_blank">Site web</a>
            <% end %>
          </div>
        </div>
    <% end %>
  </div>
</div>

<div class="row">
  <div class="col-xs-12 col-md-8 col-md-offset-2">
    <%= link_to "Aller voter", vote_url(token: @voter.token), class: %w(btn btn-block btn-primary) %>
  </div>
</div>